package com.flyfish.framework.repository.base;

import org.springframework.data.mapping.PersistentEntity;
import org.springframework.data.mapping.PersistentProperty;
import org.springframework.data.repository.core.EntityInformation;

/**
 * 标记实体的仓库
 *
 * @param <T> 泛型
 */
public interface DomainRepository<T> {

    /**
     * 获取集合名称
     *
     * @return 结果
     */
    EntityInformation<T, String> getEntityInformation();

    /**
     * 获取持久化实体信息
     *
     * @param <P> 持久化属性泛型
     * @return 结果
     */
    <P extends PersistentProperty<P>> PersistentEntity<T, P> getPersistentEntity();
}
