package com.flyfish.framework.r2dbc.metadata;

import com.flyfish.framework.annotations.Property;
import com.flyfish.framework.domain.base.Domain;
import com.flyfish.framework.r2dbc.metadata.reference.R2dbcAssociation;
import com.flyfish.framework.r2dbc.metadata.reference.R2dbcCollection;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

/**
 * 表元数据
 *
 * @author wangyu
 */
@Data
@Property("表的元数据，用于关联查询")
public class R2dbcTableMetadata {

    @Property("表名")
    private String tableName;

    @Property("表实体类名")
    private Class<? extends Domain> entityClass;

    @Property("一对一关联信息")
    private List<R2dbcAssociation> associations = new ArrayList<>();

    @Property("一对多关联信息")
    private List<R2dbcCollection> collections = new ArrayList<>();

    public R2dbcTableMetadata(Class<? extends Domain> entityClass) {
        this.entityClass = entityClass;
    }

    public void addAssociation(org.springframework.data.mapping.model.Property property, String field, boolean inner) {
        this.associations.add(R2dbcAssociation.of(property, field, inner));
    }

}
